﻿Public Class ChatPost

    Private acct As TumblePower.tumblr.Account
    Private TumblrData As TumblePower.tumblr

    Public Sub New(ByVal account As TumblePower.tumblr.Account)
        InitializeComponent()
        acct = account
    End Sub

    Private Sub CreateButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateButton.Click
        CreateButton.Text = "Please Wait..."
        CreateButton.Enabled = False
        CancelButton.Enabled = False

        TumblrData = New TumblePower.tumblr
        Dim t As New TumblePower.tumblr.Chat
        With t
            .Email = acct.Email
            .Password = acct.Password
            .Title = TitleTextBox.Text
            .TheChat = DialogueTextBox.Text
            .Tags = TagsTextBox.Text
            .IsPrivate = PrivatePostCheckBox.Checked
        End With
        Dim ap As New TumblePower.tumblr.apostChat(AddressOf TumblrData.postChat)

        Dim result As IAsyncResult = ap.BeginInvoke(t, New AsyncCallback(AddressOf CallbackMethod), ap)
    End Sub

    Private Sub CallbackMethod(ByVal ar As IAsyncResult)
        If Me.InvokeRequired Then
            Me.BeginInvoke(New AsyncCallback(AddressOf CallbackMethod), ar)
            Exit Sub
        End If

        Dim caller As TumblePower.tumblr.apostChat = DirectCast(ar.AsyncState, TumblePower.tumblr.apostChat)
        Dim returnValue As TumblePower.Status = caller.EndInvoke(ar)

        If returnValue.Code <> 201 Then
            MsgBox(returnValue.Msg)
        Else
            MsgBox("Post Created")
            Me.Close()
            TitleTextBox.Clear()
            DialogueTextBox.Clear()
            TagsTextBox.Clear()
        End If
        CreateButton.Text = "Create Post"
        CancelButton.Enabled = True
        CreateButton.Enabled = True
    End Sub

    Private Sub CancelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        If MsgBox("Cancel editing this post? All unpublished changes will be lost.", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Me.Close()
            TitleTextBox.Clear()
            DialogueTextBox.Clear()
            TagsTextBox.Clear()
        End If
    End Sub
End Class