﻿Public Class AudioPost

    Private acct As TumblePower.tumblr.Account
    Private TumblrData As TumblePower.tumblr

    Public Sub New(ByVal account As TumblePower.tumblr.Account)
        InitializeComponent()
        acct = account
    End Sub

    Private Sub CreateButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateButton.Click
        CreateButton.Text = "Please Wait..."
        CreateButton.Enabled = False
        CancelButton.Enabled = False

        TumblrData = New TumblePower.tumblr
        Dim t As New TumblePower.tumblr.Audio
        With t
            .Email = acct.Email
            .Password = acct.Password
            .ExternallyHostedUrl = URLTextBox.Text
            .Caption = DescriptionTextBox.Text
            .Tags = TagsTextBox.Text
            .IsPrivate = PrivatePostCheckBox.Checked
        End With
        Dim ap As New TumblePower.tumblr.apostAudio(AddressOf TumblrData.postAudio)

        Dim result As IAsyncResult = ap.BeginInvoke(t, New AsyncCallback(AddressOf CallbackMethod), ap)
    End Sub

    Private Sub CallbackMethod(ByVal ar As IAsyncResult)
        If Me.InvokeRequired Then
            Me.BeginInvoke(New AsyncCallback(AddressOf CallbackMethod), ar)
            Exit Sub
        End If

        Dim caller As TumblePower.tumblr.apostAudio = DirectCast(ar.AsyncState, TumblePower.tumblr.apostAudio)
        Dim returnValue As TumblePower.Status = caller.EndInvoke(ar)

        If returnValue.Code <> 201 Then
            MsgBox(returnValue.Msg)
        Else
            MsgBox("Post Created")
            Me.Close()
            DescriptionTextBox.Clear()
            TagsTextBox.Clear()
        End If
        CreateButton.Text = "Create Post"
        CancelButton.Enabled = True
        CreateButton.Enabled = True
    End Sub

    Private Sub CancelButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelButton.Click
        If MsgBox("Cancel editing this post? All unpublished changes will be lost.", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Me.Close()
            DescriptionTextBox.Clear()
            TagsTextBox.Clear()
        End If
    End Sub

    Private Sub BoldToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BoldToolStripMenuItem.Click
        Dim InsertStringBefore As String = "<b>"
        Dim InsertStringAfter As String = "</b>"
        Dim SelStart As Integer = DescriptionTextBox.SelectionStart
        Dim SelLength As Integer = DescriptionTextBox.SelectionLength

        DescriptionTextBox.Text = DescriptionTextBox.Text.Insert(SelStart + SelLength, InsertStringAfter)
        DescriptionTextBox.Text = DescriptionTextBox.Text.Insert(SelStart, InsertStringBefore)
    End Sub

    Private Sub ItalicToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItalicToolStripMenuItem.Click
        Dim InsertStringBefore As String = "<i>"
        Dim InsertStringAfter As String = "</i>"
        Dim SelStart As Integer = DescriptionTextBox.SelectionStart
        Dim SelLength As Integer = DescriptionTextBox.SelectionLength

        DescriptionTextBox.Text = DescriptionTextBox.Text.Insert(SelStart + SelLength, InsertStringAfter)
        DescriptionTextBox.Text = DescriptionTextBox.Text.Insert(SelStart, InsertStringBefore)
    End Sub

    Private Sub StrikeoutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StrikeoutToolStripMenuItem.Click
        Dim InsertStringBefore As String = "<strike>"
        Dim InsertStringAfter As String = "</strike>"
        Dim SelStart As Integer = DescriptionTextBox.SelectionStart
        Dim SelLength As Integer = DescriptionTextBox.SelectionLength

        DescriptionTextBox.Text = DescriptionTextBox.Text.Insert(SelStart + SelLength, InsertStringAfter)
        DescriptionTextBox.Text = DescriptionTextBox.Text.Insert(SelStart, InsertStringBefore)
    End Sub

    Private Sub CutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CutToolStripMenuItem.Click
        DescriptionTextBox.Cut()
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyToolStripMenuItem.Click
        DescriptionTextBox.Copy()
    End Sub

    Private Sub PasteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PasteToolStripMenuItem.Click
        DescriptionTextBox.Paste()
    End Sub

End Class